class window.Vkontakte
  
  api_id: null
  session_length: 3600 # seconds
  
  constructor: (@api_id) ->
  
  getApiId: ->
    @api_id
  
  init: ->
    log "Initializing Vkontakte API ..."
    window.vkAsyncInit = ->
      VK.init apiId: _vkontakte.getApiId()
      _vkontakte.auth()
      VK.Widgets.Like("vk-like", {type: "mini", height: 20, pageUrl: "http://beathaven.org/", text: "Like"})      

    setTimeout ->
      $('#vk_api_transport').append($('<script async="async" type="text/javascript" src="http://vkontakte.ru/js/api/openapi.js">'))
    , 0
  
  authInfo: (response) ->
    if typeof response isnt 'undefined' and response.session?
      _session = new Session(response.session)
      _session.query '/user/auth', {}, (ar) ->
        log "Authenticating user ..."
        if ar.newbie or ar.user.name == ""
          log "Requesting user name from Vkontakte ..."
          VK.Api.call 'getVariable', key: 1281, (r) ->
            _session.query '/user/update', params: { name: r.response }, (ar2) ->
              _session.setUser ar2.user
              window._session = _session
              _ajax.detectPage()
              $('#authorized').css display: 'block'
              if ar.ok_reload
                 window.location.reload()
                 false
          log "Requesting user tracks from Vkontakte ..."
          VK.Api.call 'audio.get', uid: ar.user.vkid, (r) ->
            _session.query "/user/set_first_favorites", tracks: r.response, (r2) ->
              log "Sending your Vkontakte media collection to BeatHaven ..."
              if r2.status?
                log "Got error: #{r2.status}"
              else
                log "We believe your favorite artists are #{r2.join(', ')}"
              false
            false
        else if ar.ok_reload
          window.location.reload()
          false
        else
          _session.setUser ar.user
        window._session = _session
        _ajax.detectPage()
        $('.fullscreen').hide();
      
      if response.session.expire?
        # expire_in = response.session.expire * 1000 - new Date().getTime()
        # the time is an illusion...
        expire_in = @session_length * 1000
        log "Session will expire in #{Math.round(expire_in / 1000)} seconds"
        setTimeout ->
          log "Session expired"
          _vkontakte.auth()
          false
        , expire_in + 1000
    else
      _session = new Session({})
      _session.setUser {}
      window._session = _session
      _ajax.detectPage()
      $('.fullscreen').hide();
  
  auth: ->
    log "Requesting new Vkontakte session ..."
    VK.Auth.getLoginStatus (response) ->
      _vkontakte.authInfo(response)
      false
    , 8
    false

$('#login').live 'click', ->
  VK.Auth.login (response) ->
    _vkontakte.authInfo(response)
    false
  , 8
  false

$('#logout').live 'click', ->
  VK.Auth.logout (response) ->
    _vkontakte.authInfo(response)
    $('.button-container').hide()
    false
  false
