Beathaven::Application.routes.draw do
  match '/' => 'page#index'
  match '/greetings/' => 'page#greetings'
  match '/about/' => 'page#about'
  match '/stat/' => 'page#stat'
  
  match 'user/auth' => 'user#auth'
  match 'user/update' => 'user#update'
  match 'user/set_first_favorites' => 'user#set_first_favorites'
  
  match 'lastfm/connect' => 'last_fm#connect'
  match 'lastfm/getinfo' => 'last_fm#getinfo'
  match 'lastfm/listening' => 'last_fm#listening'
  match 'lastfm/scrobble' => 'last_fm#scrobble'
  
  match 'track/update_length' => 'track#update_length'
  match 'track/report_available' => 'track#report_available'
  
  match 'playlist/(:id)' => 'playlist#data'
  match 'playlist/lastfm-top50/(:artist)' => 'playlist#lastfm_top50', constraints: { artist: /.*/ }
  
  match 'artist/autocomplete' => 'last_fm#autocomplete'
  match 'artist/(:artist)' => 'artist#data', constraints: { artist: /.*/ }
  
  match 'search' => 'artist#search'
end
